import 'dart:io';

import 'package:http/http.dart' as http;
import 'dart:convert';

import 'groups.dart';
import 'getTypes.dart';

const String baseURL = "https://pokeapi.co/api/v2/";

/// The package returns object of type 'dynamic' or '_InternalLinkedHashMap<String, dynamic>'

/// gets object by url
Future getByURL(String url) async {
  var res = await http.get(url);
  String str = await res.body;
  if (str == "Not Found") {
    throw HttpException("Item not found in API");
  }
  var got = json.decode(str);
  return got;
}

/// gets object by name of Pokemon
Future<Berry> getBerryFromId(int id) async {
  String fullURL = baseURL + "berry/" + id.toString();
  var res = await getByURL(fullURL);
  Berry obj = getBerryFromMap(res);
  return obj;
}

/// gets items in a range
Future<ResourceList> getBerries(int amount) async {
  String fullURL = baseURL + "berry/?=" + amount.toString();
  var res = await getByURL(fullURL);
  ResourceList obj = ResourceList().set(res);
  return obj;
}
