class ResourceList {
  int count;
  String next;
  var previous;
  List results;

  ResourceList set(all) {
    this.count = all["count"];
    this.next = all["next"];
    this.previous = all["previous"];
    this.results = all["results"].map((e)=>NamedAPIResource().set(e)).toList();
    return this;
  }

  String toString() {
    return "(Resource List | count: $count, next: $next, previous: $previous\n"
        "results: $results)";
  }
}

class NamedAPIResource {
  String name;
  String url;

  NamedAPIResource set(all) {
    this.name = all["name"];
    this.url = all["url"];
    return this;
  }

  String toString() {
    return "(NamedAPIResource | name: $name, url: $url)";
  }
}

class BerryFlavorMap {
  int potency;
  NamedAPIResource flavor;

  BerryFlavorMap set(potency_, flavor_) {
    this.potency = potency_;
    this.flavor = flavor_;
    return this;
  }

  String toString() {
    return "(Berry Flavour Map | potency: $potency, flavor: $flavor)";
  }
}

class Berry {
  int id;
  String name;
  int growthTime;
  int maxHarvest;
  int naturalGiftPower;
  int size;
  int smoothness;
  int soilDryness;

  NamedAPIResource firmness;
  List flavors;
  NamedAPIResource item;
  NamedAPIResource naturalGiftType;

  String toString() {
    return "Berry object\nid: $id\nname: $name\ngrowthTime: $growthTime\n"
        "maxHarvest: $maxHarvest\nnaturalGiftPower: $naturalGiftPower\n"
        "size: $size\nsmoothness: $smoothness\nsoilDryness: $soilDryness\n"
        "firmness: ${firmness.toString()}\nflavors: ${flavors.toString()}\n"
        "item: ${item.toString()}\nnaturalGiftType: ${naturalGiftType.toString()}";
  }
}
